#ifndef LLVM_COMMON_
#define LLVM_COMMON_

#include <llvm_exports.h>

// Note: we cannot link with boost here this we use the static C runtime and that's not how
// we compiled boost.
#define NV_IGNORE_BOOST
#include <core_common.h>

#include <memory>
#include <set>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include <iostream>
#include <string>

namespace nv {

NVLLVM_EXPORT void initLLVM();
NVLLVM_EXPORT void uninitLLVM();

typedef std::vector<std::string> FileList;

}

NVLLVM_EXPORT void runClang(const nv::FileList& files);

#endif
